#define INCL_BASE
#include <os2.h>

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#define THREAD_COUNT 5
#define ARR_SIZE 4096

#define CHK_DOS(stmt) \
  do { APIRET CHK_DOS_arc = (stmt); if ((CHK_DOS_arc)) { printf(#stmt "failed with %lu at #d\n", CHK_DOS_arc, __LINE__); exit(1); } } while (0)

ULONG ulTmrFreq;

PULONGLONG pullTmrTime;

void chekck_time()
{
  ULONGLONG ullTime;
  CHK_DOS(DosTmrQueryTime((QWORD*)&ullTime));

  ULONGLONG ullDiff = *pullTmrTime > ullTime ? *pullTmrTime - ullTime : 0;
  if (ullDiff)
  {
    ULONGLONG ms = ullDiff / ulTmrFreq * 1000000LLU + (ullDiff % ulTmrFreq) * 1000000LLU / ulTmrFreq;
    printf("TID %d: ALERT: previous time 0x%llX > current time 0x%llX by 0x%llX ticks (%llu us)\n",
           _gettid(), *pullTmrTime, ullTime, ullDiff, ms);
  }

  *pullTmrTime = ullTime;
}

void thread(void *data)
{
  char arr1[ARR_SIZE];
  char arr2[ARR_SIZE];

  srand(_gettid() ^ (uintptr_t)thread);

  for (int i = 0; i < ARR_SIZE; ++i)
  {
    arr1[i] = rand() % 256;
    arr2[i] = rand() % 256;
  }

  do
  {
    int cycles = rand() % 32768;
    // printf("TID %d: cycles: %d\n", _gettid(), cycles);
    for (int c = 0; c < cycles; ++c)
    {
      int i = rand() % ARR_SIZE;
      arr1[i] = arr2[ARR_SIZE - 1 - i];
      // DosSleep(0);
    }
    chekck_time();
  }
  while (1);
}

int main(int argc, char **argv)
{
  CHK_DOS(DosAllocThreadLocalMemory(sizeof(*pullTmrTime) / 4, (PULONG*)&pullTmrTime));
  CHK_DOS(DosTmrQueryFreq(&ulTmrFreq));

  printf("DosTmrQueryFreq: ulTmrFreq=%lu ticks/sec\n", ulTmrFreq);
  printf("Press ESC to exit\n");

  int tids[THREAD_COUNT] = { -1 };
  for (int i = 0; i < THREAD_COUNT; ++i)
    tids[i] = _beginthread(thread, NULL, 0, NULL);

  do
  {
    chekck_time();
    DosSleep(100);
#ifdef __EMX__
    if (_read_kbd(0, 0, 0) == 0x1b)
#else
    if (kbhit() && (getch() == 0x1b))
#endif
      break;
  } while (1);

  return 0;
}
